package org.fouram.service;

import java.util.Iterator;

import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.JsonNodeUtil;
import org.fouram.entity.SapPerGlobalInfoCHN;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.JsonNode;

@Service
public class SapPerGlobalInfoCHNService extends BaseService {

	public void saveSapData() throws Exception {
		HttpHeaders headers = getHttpHeaders();
		
		delete("SapPerGlobalInfoCHNMapper.deleteAll", null);

		String url = "https://api15.sapsf.cn/odata/v2/PerGlobalInfoCHN?$format=json";
		JsonNode node = requestService.getForObject(url, headers);
		if (node != null) {
			Iterator<JsonNode> iterator = node.get("d").get("results").elements();
			while (iterator.hasNext()) {
				JsonNode userNode = iterator.next();
				String personId = JsonNodeUtil.getValue(userNode, "personIdExternal");
				String householdRegistrationType = getLabelValue(JsonNodeUtil.getValue(userNode, "genericNumber1"));// 户口类型
				String nation = getLabelValue(JsonNodeUtil.getValue(userNode, "genericNumber4"));// 民族
				String politicalOutlook = getLabelValue(JsonNodeUtil.getValue(userNode, "customString6"));// 政治面貌
				String orgRelationshipLocation = JsonNodeUtil.getValue(userNode, "customString1");// 组织关系所在地
				String socialSecurityLocation = getLabelValue(JsonNodeUtil.getValue(userNode, "customString2"));// 社保所在地
				SapPerGlobalInfoCHN entity = SapPerGlobalInfoCHN.builder().personId(personId)
						.householdRegistrationType(householdRegistrationType).nation(nation)
						.politicalOutlook(politicalOutlook).orgRelationshipLocation(orgRelationshipLocation)
						.socialSecurityLocation(socialSecurityLocation).build();
				save("SapPerGlobalInfoCHNMapper.save", entity);
			}
		}
	}
}
